uCalc Prefix "uCalc Define Func::"
   LoadLibrary(FileName As String) As Dword At ucAddr(uc_Func_LoadLibrary)
   GetProcAddress(hModule As Dword, ProcName As String) As Dword _
      At ucAddr(uc_Func_GetProcAddress)
uCalc Prefix ""

uCalc Syntax SetDLL {DLLName} ::= uc_Push(InputBuffer, _
   "uCalc Define Func: {DLLName}(Procedure As String) As Dword _
   = GetProcAddress(LoadLibrary('{DLLName}.DLL'), Procedure)")

SetDLL User32
SetDLL Kernel32
SetDLL GDI32
SetDLL Shell32
SetDLL OleAut32
SetDLL ShlWapi
'SetDLL OpenGL32
'SetDLL WinMM
'SetDLL WinSpool[.DRV]


uCalc Prefix "uCalc Define Func:"
   CreateWindowEx(ByVal dwExStyle As Dword, ByRef lpClassName As LPCSTR, _
      ByRef lpWindowName As LPCSTR, ByVal dwStyle As DWORD, ByVal x As Long, _
      ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, _
      ByVal hWndParent As Dword, ByVal hMenu As Dword, _
      ByVal hInstance As Dword, ByVal lpParam As Dword) As Dword _
      At User32("CreateWindowExA")

   DestroyWindow(ByVal hWnd As Dword) As Long At User32("DestroyWindow")

   FillConsoleOutputCharacter(ByVal hConsoleOutput As Dword,                 _
      ByVal Character As Byte, ByVal nLength As Dword,                       _
      ByVal dwWriteCoord As Long, ByRef lpNumberOfCharactersWritten As Long) _
      As Long At Kernel32("FillConsoleOutputCharacterA")

   GetConsoleTitle(ByRef lpConsoleTitle As LPCSTR, ByVal nSize As Dword) _
      As Long At Kernel32("GetConsoleTitleA")

   GetDC(ByVal hWnd As Dword) As Dword At User32("GetDC")

   GetLargestConsoleWindowSize(ByVal hConsoleOutput As Dword) As Long _
      At Kernel32("GetLargestConsoleWindowSize")

   GetStdHandle(ByVal nStdHandle As Dword) As Dword At Kernel32("GetStdHandle")

   GetTickCount() As Dword At Kernel32("GetTickCount")

   MessageBox(ByVal hWnd As Dword, ByRef lpText As LPCSTR, _
      ByRef lpCaption As LPCSTR, ByVal uType as Dword)     _
      As Long At User32("MessageBoxA")

   ReadConsole(ByVal hConsoleInput As Dword, ByRef lpBuffer As LPCSTR,       _
      ByVal nNumberOfCharsToRead As Long, ByRef lpNumberOfCharsRead As Long, _
      ByRef lpReserved As Long) As Long At Kernel32("ReadConsoleA")

   SetConsoleCursorPosition(ByVal hConsoleOutPut As Dword, _
      ByVal CursorPosition As Long) As Long                _
      At Kernel32("SetConsoleCursorPosition")

   SetConsoleMode(ByVal hConsoleHandle As Dword, ByVal dwMode As Dword) _
      At Kernel32("SetConsoleMode")

   SetConsoleTextAttribute(ByVal hConsoleOutput As Dword, _
      ByVal vAttributes As Word) As Long At Kernel32("SetConsoleTextAttribute")

   SetConsoleTitle(ByRef lpConsoleTitle As LPCSTR) As Long _
      At Kernel32("SetConsoleTitleA")

   Sleep(ByVal dwMilliseconds As Dword) As Void At Kernel32("Sleep")

   ShellExecute(Hwnd As Dword, ByRef lpOperation As LPCSTR, _
      ByRef lpFile As LPCSTR, ByRef lpParams As LPCSTR,     _
      ByRef lpDirectory As LPCSTR, ByVal nShowCmd As Long)  _
      As DWORD At Shell32("ShellExecuteA")

   StrTrim(ByRef pszSource As LPCSTR, ByRef pszTrimChars As LPCSTR) As Long _
      At ShlWapi("StrTrimA")

   SysStringByteLen(ByVal BSTR As Dword) As Long At OleAut32("SysStringByteLen")

   WriteConsole(ByVal hConsoleOutput As Dword, ByRef lpBuffer As LPCSTR, _
      ByVal nNumberOfCharsToWrite As Long,                               _
      ByRef lpNumberOfCharsWritten As Long,                              _
      ByVal lpReservered As Long) As Long At Kernel32("WriteConsoleA")
uCalc Prefix ""

uCalc Prefix "uCalc Define Var:"
   ENABLE_PROCESSED_INPUT = 1
   ENABLE_LINE_INPUT      = 2
   ENABLE_ECHO_INPUT      = 4

   STD_INPUT_HANDLE       = -10
   STD_OUTPUT_HANDLE      = -11
   STD_ERROR_HANDLE       = -12

   StdIn  = GetStdHandle(STD_INPUT_HANDLE)
   StdOut = GetStdHandle(STD_OUTPUT_HANDLE)
   StdErr = GetStdHandle(STD_ERROR_HANDLE)

   _lpText As LPCSTR ~~ Size: 100
uCalc Prefix ""
