uCalc Echo Error
uCalc LineContinue " _"
uCalc Syntax {CPP_Comment:"//.*"} ::= 

// In order for the interpreter to perform its first bootstrapping steps, the
// following keywords were defined in the .EXE itself, but can be undefined
// or re-defined as necessary (but with special care): Extended, String, Stack,
// ucAddr, uc_Push, InputBuffer, + (Infix), - (Unary). The only permanent
// keyword is uCalc when it's the left-most word followed by a space and data.
//
// Patterns, such as brackets, parenthesis, curly braces, quotes (single and
// double), etc... are also predefined.  Rather than undefine patterns, simply
// define a new set of patterns that match the needs of your language.  A new
// definition for a given pattern will have precedence over the older one.

uCalc define Rank: -1 ~~ syntax: {BASIC_Comment:"[\x27].*"} ::=
uCalc syntax %{Const:"[^=]+"}={Val} ::= _
   uc_Push(InputBuffer, "ucalc define variable ~~ name:{Const} ~~ Value:{Val}")


uCalc Load "ucalcpb.bas" "" "' End Of Constants"
uCalc Load "Errors.uc"
uCalc Load "Types.uc"
uCalc Load "Define.uc"
uCalc Load "WinAPI.uc"
uCalc Load "Library.uc"
uCalc Load "Interp.uc"
uCalc Load "Help.uc"

// End of file
